import junit.framework.Assert;

import org.junit.Test;

public class CounterTest {
	private void testIncrement(Counter counter) {
		Assert.assertEquals(counter.getValue(), 0);

		for (int i = 1; i <= 10; i++) {
			counter.increment();
			Assert.assertEquals(counter.getValue(), i);
		}
	}

	private void testSet(Counter counter) {
		Assert.assertEquals(counter.getValue(), 0);

		counter.set(10);
		Assert.assertEquals(counter.getValue(), 10);
	}

	@Test
	public void testCounter1Set() {
		testSet(new Counter1());
	}

	@Test
	public void testCounter2Set() {
		testSet(new Counter2());
	}

	@Test
	public void testCounter1Increment() {
		testIncrement(new Counter1());
	}

	@Test
	public void testCounter2Increment() {
		testIncrement(new Counter2());
	}
}
